unit AboutDialog;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Math,
  //
  ChoiLabels;

type
  TTWatchAboutDialog = class(TForm)
    Panel1: TPanel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    OKButton: TButton;
    Label1: TLabel;
    WebSiteAddress: TLinkLabel;
    Label2: TLabel;
    LinkLabel1: TLinkLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CMShowingchanged(var Message: TMessage);
      message CM_SHOWINGCHANGED;
                          
  public
    { Public 錾 }
  end;

var
  TWatchAboutDialog: TTWatchAboutDialog;

implementation

{$R *.dfm}
const
  VERKEY_COMMENT      = 'Comments';           // Rg
  VERKEY_COMPANYNAME  = 'CompanyName';        // Ж
  VERKEY_FILEDESCRIPT = 'FileDescription';    // 
  VERKEY_FILEVERSION  = 'FileVersion';        // t@Co[W
  VERKEY_INTERNALNAME = 'InternalName';       // 
  VERKEY_COPYRIGHT    = 'LegalCopyright';     // 쌠
  VERKEY_TRADEMARKS   = 'LegalTrademarks';    // W
  VERKEY_ORIGINALFN   = 'OriginalFilename';   // t@C
  VERKEY_PRIVATEBUILD = 'PrivateBuild';       // vCx[grh
  VERKEY_PRODUCTNAME  = 'ProductName';        // i
  VERKEY_PRODUCTVER   = 'ProductVersion';     // io[W
  VERKEY_SPECIALBUILD = 'SpecialBuild';       // XyVrh

procedure TTWatchAboutDialog.CMShowingchanged(var Message: TMessage);
begin
  inherited;
  Top   := EnsureRange(Top,
    Screen.WorkAreaRect.Top, Screen.WorkAreaRect.Bottom - Height);
  Left  := EnsureRange(Left,
    Screen.WorkAreaRect.Left, Screen.WorkAreaRect.Right - Width);
end;

procedure TTWatchAboutDialog.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent  := Application.MainForm.Handle;
end;

procedure TTWatchAboutDialog.FormCreate(Sender: TObject);
const
  Translation = '\VarFileInfo\Translation';
  FileInfo = '\StringFileInfo\%0.4s%0.4s\%%s';
var
  VerInfoBuf: Pointer;
  PathLocale: String;
  procedure FileVerSetBuffer(Path: PChar);
  var
    i : Integer;
    Size, HWnd: DWORD;
    VerData: Pointer;
    VerDataLen: Longword;
  begin
    // TCY擾
    Size := GetFileVersionInfoSize(Path, HWnd);
    if Size <= 0 then raise Exception.Create('t@Co[W擾ł܂');
    // m
    GetMem(VerInfoBuf, Size);
    GetFileVersionInfo(Path, 0, Size, VerInfoBuf);
    // ϐubŃAϊe[u擾
    VerQueryValue(VerInfoBuf, Translation, VerData, VerDataLen);
    if VerDataLen <= 0 then raise Exception.Create('t@Co[W̎擾Ɏs܂B');
    // ubNʒuwAǂݍݏ
    i           := Integer(VerData^);
    PathLocale  := Format(FileInfo, [IntToHex(i and $FFFF, 4), IntToHex(i shr 16 and $FFFF, 4)]);
  end;
  function FileVerValue(Name: String): String;
  var
    VerData: Pointer;
    VerDataLen: Longword;
  begin
    // ǂݍ
    VerQueryValue(VerInfoBuf,  PChar(Format(PathLocale,[Name])), VerData, VerDataLen);
    if VerDataLen <= 0 then
      raise Exception.CreateFmt('t@Co[W%s擾ł܂łB', [Name]);
    // svȕ؂Ď擾

    SetLength(Result, VerDataLen);
    StrLCopy(PChar(Result), VerData, VerDataLen);
  end;
  procedure FileVerReleaseBuffer();
  begin
    FreeMem(VerInfoBuf);
  end;
begin
  ProgramIcon.Picture.Icon.Assign(Application.Icon);
  ProductName.Caption := Application.Title;
  try
    FileVerSetBuffer(PChar(Application.ExeName)); // ̃t@Co[W
    Version.Caption   :=  FileVerValue(VERKEY_PRODUCTVER);
    Copyright.Caption :=  FileVerValue(VERKEY_COPYRIGHT);
    Comments.Caption  :=  FileVerValue(VERKEY_COMMENT);
  finally
    FileVerReleaseBuffer;
  end;

end;

end.
 
