unit AlarmDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Math,
  //
  stdDialogs, ExIniFiles,
  //
  AlarmClass
  ;

type
  TTWatchAlarmDialog = class(TForm)
    AddAlarm: TButton;
    Bevel: TGroupBox;
    RemoveAlarm: TButton;
    EditAlarm: TButton;
    AlarmList: TListBox;
    OK: TButton;
    Cancel: TButton;
    Help: TButton;
    procedure EditAlarmClick(Sender: TObject);
    procedure AlarmListClick(Sender: TObject);
    procedure RemoveAlarmClick(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AlarmListData(Control: TWinControl; Index: Integer;
      var Data: String);
    procedure HelpClick(Sender: TObject);
  private
    { Private 錾 }
    FAlarmList: TAlarmList;
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CMShowingchanged(var Message: TMessage);
      message CM_SHOWINGCHANGED;
  public
    { Public 錾 }
  end;

var
  TWatchAlarmDialog: TTWatchAlarmDialog;

implementation

uses AlarmPropDlg;

{$R *.dfm}

{ TTWatchAlarmDialog }

procedure TTWatchAlarmDialog.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.MainForm.Handle;
end;

procedure TTWatchAlarmDialog.CMShowingchanged(var Message: TMessage);
begin
  inherited;
  // ʒu␳
  Top := EnsureRange(Top, 0, Screen.Height - Height);
  Left:= EnsureRange(Left, 0, Screen.Width - Width);
end;

//

procedure TTWatchAlarmDialog.FormDestroy(Sender: TObject);
begin
  FAlarmList.Free;
end;

procedure TTWatchAlarmDialog.AlarmListData(Control: TWinControl;
  Index: Integer; var Data: String);
begin
  Data := FAlarmList.Items[Index].ToString;
end;

procedure TTWatchAlarmDialog.AlarmListClick(Sender: TObject);
begin
  RemoveAlarm.Enabled := AlarmList.ItemIndex > -1;
  EditAlarm.Enabled   := RemoveAlarm.Enabled;
end;

procedure TTWatchAlarmDialog.EditAlarmClick(Sender: TObject);
var
  dlg : TTWatchAlarmPropertyDialog;
begin
  dlg := TTWatchAlarmPropertyDialog.Create(Self);
  try
    if TButton(Sender).Tag = 1 then // ҏW
      dlg.Alarm := FAlarmList[AlarmList.ItemIndex];
    if dlg.ShowModal = mrOk then begin
      if TButton(Sender).Tag = 1 then // ҏW
        FAlarmList[AlarmList.ItemIndex] := dlg.Alarm
      else begin
        FAlarmList.Add(dlg.Alarm);
        AlarmList.Count := FAlarmList.Count;
      end;
      AlarmList.Invalidate;
    end;
  finally
    dlg.Release;
  end;
end;

procedure TTWatchAlarmDialog.RemoveAlarmClick(Sender: TObject);
begin
  if Confirm('폜܂H') then begin
    FAlarmList.Delete(AlarmList.ItemIndex);
    AlarmList.Count := FAlarmList.Count;
  end;
end;

procedure TTWatchAlarmDialog.OKClick(Sender: TObject);
begin
  FAlarmList.SaveToFile;
end;

//

procedure TTWatchAlarmDialog.FormCreate(Sender: TObject);
begin
  FAlarmList := TAlarmList.Create;
  FAlarmList.LoadFromFile;
  AlarmList.Count := FAlarmList.Count;
end;

procedure TTWatchAlarmDialog.HelpClick(Sender: TObject);
begin
  Application.HelpContext(HelpContext);
end;

end.

