unit AlarmPropDlg;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, Math,
  // ݂ http://Onpu.jpn.ch/
  Refer, stdInt, ExIniFiles, HistoryComboBox,
  //
  AlarmClass
  ;

type
  TTWatchAlarmPropertyDialog = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Label1: TLabel;
    TabControl: TTabControl;
    DatePickerLabel: TLabel;
    DatePicker: TDateTimePicker;
    TimePicker: TDateTimePicker;
    TimePickerLabel: TLabel;
    WeeksGroup: TGroupBox;
    CheckSunday: TCheckBox;
    CheckMonday: TCheckBox;
    CheckTuesDay: TCheckBox;
    CheckWednesDay: TCheckBox;
    CheckThursDay: TCheckBox;
    CheckFriDay: TCheckBox;
    CheckSaturDay: TCheckBox;
    CheckAllDay: TCheckBox;
    Label6: TLabel;
    FilePath: TReferEdit;
    SnoozeLabel: TLabel;
    Snooze: TComboBox;
    RemoveOnExec: TCheckBox;
    ShowMessage: THistoryComboBox;
    procedure CheckWeeksClick(Sender: TObject);
    procedure CheckAllDayClick(Sender: TObject);
    procedure TabControlChange(Sender: TObject);
    procedure RemoveOnExecClick(Sender: TObject);
    procedure SnoozeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    function GetAlarm: TAlarmData;
    procedure SetAlarm(const Value: TAlarmData);
    { Private 錾 }
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CMShowingchanged(var Message: TMessage);
      message CM_SHOWINGCHANGED;
  public
    { Public 錾 }
    property  Alarm: TAlarmData read  GetAlarm  write SetAlarm;
  end;

var
  TWatchAlarmPropertyDialog: TTWatchAlarmPropertyDialog;

implementation

uses Main, DateUtils, IniFiles;

{$R *.dfm}

{ TTWatchAlarmPropertyDialog }

procedure TTWatchAlarmPropertyDialog.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := (Owner as TForm).Handle;
end;

procedure TTWatchAlarmPropertyDialog.CMShowingchanged(
  var Message: TMessage);
begin
  inherited;
  // ʒu␳
  Top := EnsureRange(Top, 0, Screen.Height - Height);
  Left:= EnsureRange(Left, 0, Screen.Width - Width);
end;

//

procedure TTWatchAlarmPropertyDialog.FormCreate(Sender: TObject);
begin
  DatePicker.Date := Today;
  TimePicker.Time := Now;
  CheckAllDay.Checked := True;
end;

procedure TTWatchAlarmPropertyDialog.TabControlChange(Sender: TObject);
var indx: Integer;
begin
  indx := TabControl.TabIndex;
  WeeksGroup.Visible      := indx = 0;
  DatePickerLabel.Visible := indx = 1;
  DatePicker.Visible      := indx = 1;
  TimePickerLabel.Visible := indx <>2;
  TimePicker.Visible      := indx <>2;
  SnoozeLabel.Visible     := indx <>2;
  Snooze.Visible          := indx <>2;
  RemoveOnExec.Checked    := indx = 1;
  RemoveOnExec.OnClick(nil);

end;

procedure TTWatchAlarmPropertyDialog.CheckWeeksClick(Sender: TObject);
var
  i: Integer;
  b: Boolean;
begin
  if CheckAllDay.Tag = 1 then exit;
  CheckAllDay.Tag := 1;
  try
    b := True;
    // ׂẴ`FbN{bNX`FbNԂȂ΁A
    // CheckAllDay`FbN
    for i := 0 to WeeksGroup.ControlCount - 1 do
      if WeeksGroup.Controls[i] <> CheckAllDay then
        b := b and TCheckBox(WeeksGroup.Controls[i]).Checked;
    CheckAllDay.Checked := b;
  finally
    CheckAllDay.Tag := 0;
  end;
end;

procedure TTWatchAlarmPropertyDialog.CheckAllDayClick(Sender: TObject);
var
  i: Integer;
begin
  if CheckAllDay.Tag = 1 then exit;
  CheckAllDay.Tag := 1;
  try
    // ׂẴ`FbN{bNXԂA
    // CheckAllDayɍ킹
    for i := 0 to WeeksGroup.ControlCount - 1 do
      if WeeksGroup.Controls[i] <> CheckAllDay then
        TCheckBox(WeeksGroup.Controls[i]).Checked := CheckAllDay.Checked;
  finally
    CheckAllDay.Tag := 0;
  end;
end;

procedure TTWatchAlarmPropertyDialog.RemoveOnExecClick(Sender: TObject);
begin
  // ꂪTrueƁASnoozeoȂ̂ŁEEE
  if RemoveOnExec.Checked then
    Snooze.ItemIndex := 0;
end;

procedure TTWatchAlarmPropertyDialog.SnoozeClick(Sender: TObject);
begin
  // ꂪ0ȊOƁARemoveOnExecoȂ
  if Snooze.ItemIndex <> 0 then
    RemoveOnExec.Checked := False;
end;

function TTWatchAlarmPropertyDialog.GetAlarm: TAlarmData;
var
  h, m, s, ms : Word;
  w           : TWeeks;
begin
  Result          := TAlarmData.Create;
  Result.AlarmKind:= TAlarmKind(TabControl.TabIndex);
  Result.Date     := DatePicker.Date;
  DecodeTime(TimePicker.Time, h, m, s, ms);
  Result.Time     := EncodeTime(h, m, 0, 0);
  w               := [];
  if CheckSunday.Checked then Include(w, wSun);
  if CheckMonday.Checked then Include(w, wMon);
  if CheckTuesDay.Checked then Include(w, wTue);
  if CheckWednesDay.Checked then Include(w, wWed);
  if CheckThursDay.Checked then Include(w, wThu);
  if CheckFriDay.Checked then Include(w, wFri);
  if CheckSaturDay.Checked then Include(w, wSat);
  Result.Weeks    := w;
  Result.Snooze   := TSnoozeType(Snooze.ItemIndex);
  Result.Message  := ShowMessage.Text;
  Result.Command  := FilePath.FileName;
  Result.RemoveOnExec
                  := RemoveOnExec.Checked;
end;

procedure TTWatchAlarmPropertyDialog.SetAlarm(const Value: TAlarmData);
begin
  TabControl.TabIndex   := Integer(Value.AlarmKind);
  DatePicker.Date       := Value.Date;
  TimePicker.Time       := Value.Time;
  CheckSunday.Checked   := wSun in Value.Weeks;
  CheckMonday.Checked   := wMon in Value.Weeks;
  CheckTuesDay.Checked  := wTue in Value.Weeks;
  CheckWednesDay.Checked:= wWed in Value.Weeks;
  CheckThursDay.Checked := wThu in Value.Weeks;
  CheckFriDay.Checked   := wFri in Value.Weeks;
  CheckSaturDay.Checked := wSat in Value.Weeks;
  Snooze.ItemIndex      := Integer(Value.Snooze);
  ShowMessage.Text      := Value.Message;
  FilePath.FileName     := Value.Command;
  RemoveOnExec.Checked  := Value.RemoveOnExec;
end;

end.

