unit PreferenceDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls, ComCtrls, Menus, StrUtils, AppEvnts,
  //
  stdDialogs, StrToken, Refer, stdMedia,  ExIniFiles;

type
  TTWatchPreferenceDialog = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    PageControl: TPageControl;
    DisplaySetting: TTabSheet;
    Label1: TLabel;
    DisplayFont: TComboBox;
    Label2: TLabel;
    DateSize: TEdit;
    DateSizeUpDown: TUpDown;
    Label3: TLabel;
    TimeSize: TEdit;
    TimeSizeUpDown: TUpDown;
    Label4: TLabel;
    DateColor: TColorBox;
    TimeColor: TColorBox;
    Label5: TLabel;
    BackColor: TColorBox;
    Label6: TLabel;
    FormatSetting: TTabSheet;
    DateFormat: TGroupBox;
    DateCombo: TComboBox;
    DatePreview: TLabel;
    TimeFormat: TGroupBox;
    TimePreview: TLabel;
    TimeCombo: TComboBox;
    ToolTipFormat: TGroupBox;
    ToolTipPreview: TLabel;
    ToolTipCombo: TComboBox;
    AlarmSetting: TTabSheet;
    Label7: TLabel;
    TransparencyUpDown: TUpDown;
    Transparency: TEdit;
    NTPTimeSetting: TTabSheet;
    Label9: TLabel;
    NTPServer: TComboBox;
    Timeset: TCheckBox;
    TimesetInterval: TEdit;
    TimesetIntervalUpDown: TUpDown;
    TimesetNow: TButton;
    DateTemplates: TPopupMenu;
    y1: TMenuItem;
    yyyy41: TMenuItem;
    ee21: TMenuItem;
    m1: TMenuItem;
    d1: TMenuItem;
    TimeTemplates: TPopupMenu;
    a1: TMenuItem;
    A2: TMenuItem;
    h1: TMenuItem;
    m2: TMenuItem;
    s1: TMenuItem;
    h2: TMenuItem;
    y2: TMenuItem;
    ddddd1: TMenuItem;
    ddddd2: TMenuItem;
    d2: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    t1: TMenuItem;
    t2: TMenuItem;
    ToolTipTemplates: TPopupMenu;
    N3: TMenuItem;
    ampm1: TMenuItem;
    AMPMAMPM1: TMenuItem;
    hh21: TMenuItem;
    h11: TMenuItem;
    nn21: TMenuItem;
    ss21: TMenuItem;
    N4: TMenuItem;
    t3: TMenuItem;
    N5: TMenuItem;
    yyyy42: TMenuItem;
    yy21: TMenuItem;
    ee22: TMenuItem;
    gg1: TMenuItem;
    mm21: TMenuItem;
    dd21: TMenuItem;
    ddd1: TMenuItem;
    N6: TMenuItem;
    ddddd3: TMenuItem;
    dddddd1: TMenuItem;
    N7: TMenuItem;
    c1: TMenuItem;
    tch1: TMenuItem;
    tcn1: TMenuItem;
    tcs1: TMenuItem;
    tcms1: TMenuItem;
    tt1: TMenuItem;
    N8: TMenuItem;
    md2: TMenuItem;
    DateRefer: TButton;
    TimeRefer: TButton;
    ToolTipRefer: TButton;
    tcm1: TMenuItem;
    Label10: TLabel;
    InformationNote: TGroupBox;
    InformationShowSound: TCheckBox;
    InformationShowBeep: TCheckBox;
    InformationNotePath: TReferEdit;
    InformationNotePlay: TButton;
    HelpLabel: TLabel;
    ApplicationEvents: TApplicationEvents;
    TimeSignals: TGroupBox;
    TimeSignalJustTime: TCheckBox;
    TimeSignalHalfTime: TCheckBox;
    TimeSignalTimesLoop: TCheckBox;
    TimeSignalPath: TReferEdit;
    TimeSignalPlay: TButton;
    Label8: TLabel;
    BGImage: TReferEdit;
    DateShadow: TCheckBox;
    TimeShadow: TCheckBox;
    StandardAlarm: TGroupBox;
    StandardAlarmPath: TReferEdit;
    StandardAlarmPlay: TButton;
    AlarmToBeep: TCheckBox;
    Help: TButton;
    procedure InsFormatClick(Sender: TObject);
    procedure FormatComboChange(Sender: TObject);
    procedure TimesetNowClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure TimesetClick(Sender: TObject);
    procedure FormatReferClick(Sender: TObject);
    procedure ApplicationEventsHint(Sender: TObject);
    procedure InformationShowSoundClick(Sender: TObject);
    procedure InformationShowBeepClick(Sender: TObject);
    procedure NotePlayClick(Sender: TObject);
    procedure TimeSignalJustTimeClick(Sender: TObject);
    procedure TimeSignalHalfTimeClick(Sender: TObject);
    procedure AlarmToBeepClick(Sender: TObject);
    procedure HelpClick(Sender: TObject);
  private
    { Private 錾 }
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CMShowingchanged(var Message: TMessage);
      message CM_SHOWINGCHANGED;
  public
    { Public 錾 }
  end;

var
  TWatchPreferenceDialog: TTWatchPreferenceDialog;

implementation

uses Main, SNTP, IniFiles, Types, Math;

{$R *.dfm}

(* I[o[Ch\bh *)

procedure TTWatchPreferenceDialog.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent  := Application.MainForm.Handle;
end;

procedure TTWatchPreferenceDialog.CMShowingchanged(var Message: TMessage);
begin
  inherited;
  Top   := EnsureRange(Top,
    Screen.WorkAreaRect.Top, Screen.WorkAreaRect.Bottom - Height);
  Left  := EnsureRange(Left,
    Screen.WorkAreaRect.Left, Screen.WorkAreaRect.Right - Width);
end;

(* tH[Cxg *)

procedure TTWatchPreferenceDialog.FormCreate(Sender: TObject);
begin
  PageControl.ActivePageIndex   := 0;
  DisplayFont.Items             := Screen.Fonts;
  BGImage.ReferButton.Filter    := GraphicFilter(TBitmap);
  BGImage.ReferButton.Hint      := '';
  InformationNotePath.ReferButton.Hint
                                := '';
  TimeSignalPath.ReferButton.Hint
                                := '';
  DateRefer.Tag                 := Integer(DateTemplates);
  TimeRefer.Tag                 := Integer(TimeTemplates);
  ToolTipRefer.Tag              := Integer(ToolTipTemplates);
  with TMemIniFileEx.CreateDef do
  try
    Section := 'General';
    DateCombo.Text              := ReadStringS('DateFormat', 'yyyy/mm/dd');
    TimeCombo.Text              := ReadStringS('TimeFormat', 'ampm h:nn:ss');
    ToolTipCombo.Text           := ReadStringS('ToolTipFormat', '');
    NTPServer.Text              := ReadStringS('NTPAddress', 'ntp1.jst.mfeed.ad.jp');
    Timeset.Checked             := ReadBoolS('AutoNTP', False);
    TimesetIntervalUpDown.Position
                                := ReadIntegerS('AutoNTPInterval', 10);
    TransparencyUpDown.Position := ReadIntegerS('Transparency', 255);
    BackColor.Selected          := ReadColorS('BackColor', clBtnFace);
    BGImage.FileName            := ReadPathS('BGImage');
    Section := 'Font';
    DisplayFont.ItemIndex       :=
      DisplayFont.Items.IndexOf(ReadStringS('FontName', Self.Font.Name));
    DateSizeUpDown.Position     :=
      ReadIntegerS('DateSize', Self.Font.Size);
    TimeSizeUpDown.Position     :=
      ReadIntegerS('TimeSize', Self.Font.Size * 2);
    DateShadow.Checked          := ReadBoolS('DateShadow');
    TimeShadow.Checked          := ReadBoolS('TimeShadow');
    DateColor.Selected          := ReadColorS('DateColor', clWindowText);
    TimeColor.Selected          := ReadColorS('TimeColor', clWindowText);
    Section := 'InformationNote';
    InformationShowSound.Checked:= ReadBoolS('Play');
    InformationShowBeep.Checked := ReadBoolS('OnBeep');
    InformationNotePath.FileName:= ReadPathS('Path');
    Section := 'TimeSignal';
    TimeSignalJustTime.Checked  := ReadBoolS('PlayJustTime');
    TimeSignalHalfTime.Checked  := ReadBoolS('PlayHalfTime');
    TimeSignalTimesLoop.Checked := ReadBoolS('TimesLoop');
    TimeSignalPath.FileName     := ReadPathS('Path');
    Section := 'Alarm';
    AlarmToBeep.Checked         := ReadBoolS('AlarmToBeep');
    StandardAlarmPath.FileName  := ReadPathS('Path');

  finally
    Free;
  end;
  DateCombo.OnChange(DateCombo);
  TimeCombo.OnChange(TimeCombo);
  ToolTipCombo.OnChange(ToolTipCombo);
end;

procedure TTWatchPreferenceDialog.ApplicationEventsHint(Sender: TObject);
begin
  HelpLabel.Caption := GetLongHint(Application.Hint);
end;

(*  *)

procedure TTWatchPreferenceDialog.FormatComboChange(Sender: TObject);
var
  i: Integer;
  l: TLabel;
begin
  l := nil;
  // LabelT
  with TComboBox(Sender) do begin
    for i := 0 to Parent.ControlCount - 1 do
      if Parent.Controls[i] is TLabel then
        l := Parent.Controls[i] as TLabel;
    l.Caption :=
      TTWatchDisplayForm.GetFormattedText(Text, Now);
  end;
end;

procedure TTWatchPreferenceDialog.InsFormatClick(Sender: TObject);
var c: TComboBox;
begin
  with TMenuItem(Sender) do begin
    case Tag of
      0:c := DateCombo;
      1:c := TimeCombo;
      2:c := ToolTipCombo;
    else
      c := nil;
    end;
    c.SelText := PickConstToken(Caption, ' ');
  end;
end;

procedure TTWatchPreferenceDialog.FormatReferClick(Sender: TObject);
begin
  with Mouse.CursorPos do
    TPopupMenu(TComboBox(Sender).Tag).Popup(X, Y);
end;

(* A[/ *)

procedure TTWatchPreferenceDialog.InformationShowSoundClick(
  Sender: TObject);
begin
  InformationShowBeep.Enabled := InformationShowSound.Checked;
  InformationShowBeepClick(Sender);
end;

procedure TTWatchPreferenceDialog.InformationShowBeepClick(
  Sender: TObject);
begin
  InformationNotePath.Enabled :=
    not InformationShowBeep.Checked and InformationShowSound.Checked;
  InformationNotePlay.Enabled :=
    not InformationShowBeep.Checked and InformationShowSound.Checked;
end;

procedure TTWatchPreferenceDialog.TimeSignalJustTimeClick(Sender: TObject);
begin
  TimeSignalTimesLoop.Enabled := TimeSignalJustTime.Checked;
  TimeSignalHalfTimeClick(Sender);
end;

procedure TTWatchPreferenceDialog.TimeSignalHalfTimeClick(Sender: TObject);
begin
  TimeSignalPath.Enabled  :=
    TimeSignalJustTime.Checked or TimeSignalHalfTime.Checked;
  TimeSignalPlay.Enabled  :=
    TimeSignalJustTime.Checked or TimeSignalHalfTime.Checked;
end;

procedure TTWatchPreferenceDialog.AlarmToBeepClick(Sender: TObject);
begin
  StandardAlarmPath.Enabled := AlarmToBeep.Checked;
  StandardAlarmPlay.Enabled := AlarmToBeep.Checked;
end;

procedure TTWatchPreferenceDialog.NotePlayClick(
  Sender: TObject);
var
  i: Integer;
  e: TReferEdit;
begin
  e := nil;
  // TReferEditT
  with TButton(Sender) do begin
    for i := 0 to Parent.ControlCount - 1 do
      if Parent.Controls[i] is TReferEdit then
        e := Parent.Controls[i] as TReferEdit;
    snd(e.FileName);
  end;
end;

(* 킹 *)

procedure TTWatchPreferenceDialog.TimesetClick(Sender: TObject);
begin
  TimesetInterval.Enabled := Timeset.Checked;
  TimesetIntervalUpDown.Enabled := TimesetInterval.Enabled;
end;

procedure TTWatchPreferenceDialog.TimesetNowClick(Sender: TObject);
begin
  Alert(Format('킹%s܂',
    [IfThen(SNTP.NTPSetTime(NTPServer.Text), '', 's')]));
end;

(* ̂ق *)

procedure TTWatchPreferenceDialog.OKBtnClick(Sender: TObject);
begin
  with TMemIniFileEx.CreateDef do
  try
    Section := 'General';
    WriteStringS('DateFormat', DateCombo.Text);
    WriteStringS('TimeFormat', TimeCombo.Text);
    WriteStringS('ToolTipFormat', ToolTipCombo.Text);
    WriteStringS('NTPAddress', NTPServer.Text);
    WriteIntegerS('Transparency', TransparencyUpDown.Position);
    WriteColorS('BackColor', BackColor.Selected);
    WritePathS('BGImage', BGImage.FileName);
    WriteBoolS('AutoNTP', Timeset.Checked);
    WriteIntegerS('AutoNTPInterval', TimesetIntervalUpDown.Position);
    Section := 'Font';
    WriteStringS('FontName', DisplayFont.Text);
    WriteIntegerS('DateSize', DateSizeUpDown.Position);
    WriteIntegerS('TimeSize', TimeSizeUpDown.Position);
    WriteBoolS('DateShadow', DateShadow.Checked);
    WriteBoolS('TimeShadow', TimeShadow.Checked);         
    WriteColorS('DateColor', DateColor.Selected);
    WriteColorS('TimeColor', TimeColor.Selected);
    Section := 'InformationNote';
    WriteBoolS('Play', InformationShowSound.Checked);
    WriteBoolS('OnBeep', InformationShowBeep.Checked);
    WritePathS('Path', InformationNotePath.FileName);
    Section := 'TimeSignal';
    WriteBoolS('PlayJustTime', TimeSignalJustTime.Checked);
    WriteBoolS('PlayHalfTime', TimeSignalHalfTime.Checked);
    WriteBoolS('TimesLoop', TimeSignalTimesLoop.Checked);
    WritePathS('Path', TimeSignalPath.FileName);
    Section := 'Alarm';
    WriteBoolS('AlarmToBeep', AlarmToBeep.Checked);
    WritePathS('Path', StandardAlarmPath.FileName);
    UpdateFile;
  finally
    Free;
  end;
end;

procedure TTWatchPreferenceDialog.HelpClick(Sender: TObject);
begin
  Application.HelpContext(PageControl.ActivePage.HelpContext);
end;

end.

