unit TimeDlg;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, Math,
  // ݂ http://Onpu.jpn.ch/
  StrToken, ExIniFiles;

type
  TTWatchSetTimerDialog = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel: TGroupBox;
    Hour: TEdit;
    HourUpDown: TUpDown;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Minute: TEdit;
    MinuteUpDown: TUpDown;
    SecondUpDown: TUpDown;
    Second: TEdit;
    Label4: TLabel;
    TimePresets: TComboBox;
    AddPreset: TButton;
    RemovePreset: TButton;
    procedure TimePresetsClick(Sender: TObject);
    procedure AddPresetClick(Sender: TObject);
    procedure RemovePresetClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    function GetTime: Cardinal;
    procedure SetTime(const Value: Cardinal);
    { Private 錾 }
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CMShowingchanged(var Message: TMessage);
      message CM_SHOWINGCHANGED;

  public
    { Public 錾 }
    property  Time: Cardinal  read  GetTime write SetTime;
  end;

var
  TWatchSetTimerDialog: TTWatchSetTimerDialog;

implementation

uses IniFiles;

{$R *.dfm}

{ TTWatchSetTimeDialog }

procedure TTWatchSetTimerDialog.FormCreate(Sender: TObject);
begin
  with TMemIniFileEx.CreateDef do begin
  try
    ReadLines('TimePresets', TimePresets.Items);
  finally
    Free;
  end;
  end;
end;

procedure TTWatchSetTimerDialog.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.MainForm.Handle;
end;

procedure TTWatchSetTimerDialog.CMShowingchanged(var Message: TMessage);
begin
  inherited;
  // ʒu␳
  Top := EnsureRange(Top, 0, Screen.Height - Height);
  Left:= EnsureRange(Left, 0, Screen.Width - Width);
end;

procedure TTWatchSetTimerDialog.TimePresetsClick(Sender: TObject);
var str: String;
begin
  str := TimePresets.Text;
  SecondUpDown.Position := StrToIntDef(PickTokenRev(str, ':'), 0);
  MinuteUpDown.Position := StrToIntDef(PickTokenRev(str, ':'), 0);
  HourUpDown.Position   := StrToIntDef(PickTokenRev(str, ':'), 0);
end;

procedure TTWatchSetTimerDialog.AddPresetClick(Sender: TObject);
begin
  if HourUpDown.Position = 0 then
    TimePresets.AddItem(Format('%d:%.2d',
      [MinuteUpDown.Position, SecondUpDown.Position]), nil)
  else
    TimePresets.AddItem(Format('%d:%.2d:%.2d',
      [HourUpDown.Position, MinuteUpDown.Position,
        SecondUpDown.Position]), nil);
end;

procedure TTWatchSetTimerDialog.RemovePresetClick(Sender: TObject);
begin
  if TimePresets.ItemIndex >= 0 then
    TimePresets.DeleteSelected; 
end;

function TTWatchSetTimerDialog.GetTime: Cardinal;
begin
  Result := (HourUpDown.Position * 60 * 60 +
    MinuteUpDown.Position * 60 +
    SecondUpDown.Position) * 1000;
end;

procedure TTWatchSetTimerDialog.SetTime(const Value: Cardinal);
var s: Integer;
begin
  s                     := Value div 1000;
  HourUpDown.Position   := s div (60 * 60);
  s                     := s mod (60 * 60);
  MinuteUpDown.Position := s div 60;
  SecondUpDown.Position := s mod 60;
end;

procedure TTWatchSetTimerDialog.OKBtnClick(Sender: TObject);
begin
  with TMemIniFileEx.CreateDef do begin
  try
    WriteLines('TimePresets', TimePresets.Items);
    UpdateFile;
  finally
    Free;
  end;
  end;
end;

end.

