unit SNTP;

interface
  uses Windows, Classes,
  // T[hp[eB
  IdSNTP;
  function NTPGetTime(Server: String): TDateTime;
  function NTPSetTime(Server: String): Boolean;
implementation

uses SysUtils;

function NTPGetTime(Server: String): TDateTime;
var
  sntp: TIdSNTP;
  EX  : TClass;
begin
  try
    sntp            := TIdSNTP.Create(nil);
    EX              := ExceptionClass;
    ExceptionClass  := EAbort;
    try
      sntp.Host     := Server;
      sntp.ReceiveTimeout
                    := 3000;
      Result        := sntp.DateTime;
    finally
      ExceptionClass:= EX;
      sntp.Free;
    end;
  except
    Result := 0.0;
  end;
end;

function NTPSetTime(Server: String): Boolean;
var
  sntp: TIdSNTP;
  EX  : TClass;
begin
  try
    sntp            := TIdSNTP.Create(nil);
    EX              := ExceptionClass;
    ExceptionClass  := EAbort;
    try
      sntp.Host     := Server;
      sntp.ReceiveTimeout
                    := 3000;
      Result        := sntp.SyncTime;
    finally
      ExceptionClass:= EX;
      sntp.Free;
    end;
  except
    Result := False;
  end;
end;

end.
